import java.util.*;
public class ArboreBinRec {
  private Object info;
  private ArboreBinRec subarboreStanga, subarboreDreapta;

  public ArboreBinRec(Object inf) {
    info=inf;
    subarboreStanga=subarboreDreapta=null;
  }

  public ArboreBinRec(Object inf, ArboreBinRec st, ArboreBinRec dr) {
    info=inf;
    subarboreStanga=st;
    subarboreDreapta=dr;
  }

  public Object info() {
    return info;
  }

  public ArboreBinRec subarboreStanga() {
    return subarboreStanga;
  }

  public ArboreBinRec subarboreDreapta() {
    return subarboreDreapta;
  }

  public Object puneInfo(Object obj) {
    Object infoVeche=info;
    info=obj;
    return infoVeche;
  }

  public ArboreBinRec puneFiuStanga(ArboreBinRec fiuStanga) {
    ArboreBinRec fiuInlocuit=subarboreStanga;
    subarboreStanga=fiuStanga;
    return fiuInlocuit;
  }

  public ArboreBinRec puneFiuDreapta(ArboreBinRec fiuDreapta) {
    ArboreBinRec fiuInlocuit=subarboreDreapta;
    subarboreDreapta=fiuDreapta;
    return fiuInlocuit;
  }

  

  public List preordine(List lista) {
    lista.add(info);
    if(subarboreStanga!=null)
      subarboreStanga.preordine(lista);
    if(subarboreDreapta!=null)
      subarboreDreapta.preordine(lista);
    return lista;
  }

  public List inordine(List lista) {
    if(subarboreStanga!=null)
      subarboreStanga.inordine(lista);
    lista.add(info);
    if(subarboreDreapta!=null)
      subarboreDreapta.inordine(lista);
    return lista;
  }

  public List postordine(List lista) {
    if(subarboreStanga!=null)
      subarboreStanga.postordine(lista);
    if(subarboreDreapta!=null)
      subarboreDreapta.postordine(lista);
    lista.add(info);
    return lista;
  }
}
