/* Clasa care genereaza succesiv numerele de lungime data dintr-un
   sistem de numeratie ale carui cifre sunt date in tabloul tabCifre.
*/

public class Numarare extends Backtracking {
  String[] tabCifre; // tabloul cifrelor sistemului de numeratie
  int nrCifre; // lungimea numerelor generate

  /* Constructorul primeste ca parametri tabloul de cifre al sis-
     temului de numeratie si lungimea numerelor generate.
     La initializare se pune in stiva un element de garda, care
     nu contine nici o cifra, dar poate avea ca succesor prima
     cifra a numarului generat
  */
  public Numarare(String[] tablouCifre, int numarCifre) {
    tabCifre=tablouCifre;
    nrCifre=numarCifre;
    ElemStiva elementGarda=new ElemStiva(null);
    stiva.add(elementGarda);
  }

  /* Este solutie orice numar de lungime nrCifre. Cifrele incep de
     la indicele 1 din stiva, deoarece primul (de indice 0) este
     elementul de garda
  */
  protected Object solutie() {
    if(stiva.size()<nrCifre+1) return null;
    StringBuffer solutie=new StringBuffer();
    for(int j=1; j<stiva.size(); j++) {
      ElemStiva elementCurent=(ElemStiva)stiva.get(j);
      int indice=((Integer)elementCurent.element).intValue();
      solutie.append(tabCifre[indice]);
    }
    return solutie.toString();
  }

  /* Succesor al obiectului din varful stivei poate fi orice obiect
     din tabloul tabCifre. Se ia cel care urmeaza dupa ultimul folosit
  */
  protected Object succesor() {
    if(tabCifre.length==0) return null;
    if(stiva.isEmpty() || stiva.size()==(nrCifre+1))
           return null;
    int j;
    ElemStiva varfStiva=(ElemStiva)stiva.get(stiva.size()-1);
    if(varfStiva.ultimSuccesorVizitat==null) return new Integer(0);
    j=((Integer)varfStiva.ultimSuccesorVizitat).intValue();
    if(j>=tabCifre.length-1) return null;
    return new Integer(j+1);
  }

  protected boolean esteValid(Object succesor) {
    /* Orice succesor este valid */
    return true;
  }
}
    