/* Testarea clasei Rucsac, pentru rezolvarea problemei rucsacului
   prin metoda Greedy.
   Utilizare: java TestRucsac <greutate_maxima> <pretUnitar  greutateDisponibila>*
   Se da ca prim parametru grautatea maxima a rucsacului, urmata de 
   pretul unitar si greutatea disponibila ale fiecaruia din produsele necesare
*/

import java.util.*;

class TestRucsac {
  public static void main(String args[]) {
    double greutateMaxima=0;
    Rucsac.ProdusNecesar pr;
    Collection produseNecesare=new ArrayList();
    Collection s;

    /* Se verifica  daca exista parametri in linia de comanda */
    if(args.length<3) {
      System.out.println("Utilizare: java Rucsac <greutateMaxima> " +
          "<prioritate greutate>*");
     System.exit(0);
    }

    /* Se preiau parametrii din linia de comanda */
    try {
      greutateMaxima=Double.parseDouble(args[0]);
      for(int i=1; i<args.length; i+=2) {
        pr=new Rucsac.ProdusNecesar();
        pr.pretUnitar=Double.parseDouble(args[i]);
        pr.greutateDisponibila=Double.parseDouble(args[i+1]);
        produseNecesare.add(pr);
      }
    }
    catch(Exception e) {
      System.out.println("Valori incorecte\n"+e);
      System.exit(0);
    }

    /* Se creeaza un obiect din clasa Rucsac */
    Rucsac rucsac=new Rucsac(produseNecesare, greutateMaxima);

    /* Se apeleaza metoda Greedy pentru rucsac */
    s=rucsac.greedy();

    /* Se afiseaza rezultatul (lista obiectelor puse in rucsac) */
    System.out.println(s.toString());
    /* Se calculeaza costul continutului */
    double cost=0;
    int nrProduse=0;
    Iterator iter=s.iterator();
    while (iter.hasNext()) {
      pr=(Rucsac.ProdusNecesar)iter.next();
      cost+=pr.cantitate*pr.pretUnitar;
      nrProduse++;
    }
    System.out.println("Rucsacul contine "+nrProduse+" produse");
    System.out.println("Costul continutului este "+cost); 
  }
}